#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

eval destroy [winfo child .]

set w .h
set c .h.c
set bg .h.bg
set bh .h.bh
set bb .h.bb
set wt .h.t
set ws .h.s
# set hc {Aleph Ayin Bet Dalet Gimal Heh Het Kaf Kaf2 Kuf Lamed Mem \
        Mem2 Nun Nun2 Peh Peh2 Resh Samech Shin Taf Tet Tzadi Tzadi2 \
        Vav Yod Zayin}
set hc {Aleph Bet Gimal Dalet Heh Vav Zayin Het Tet Yod Kaf Kaf2
        Lamed Mem Mem2 Nun Nun2 Samech Ayin Peh Tzadi Tzadi2 Kuf 
        Resh Shin Taf }
set gc {Agr Bgr Ggr Dgr Egr Zgr EEgr THgr Igr Kgr Lgr Mgr Ngr Xgr Ogr \
        Pgr Rgr Sgr Tgr Ugr PHgr KHgr PSgr OHgr}
set hcc {\) B G D H W Z X + Y K K2 L M M2 N N2 S \( P \
        C C2 Q R \# T }
set gcc {A B G D E Z H Q I K L M N C O P R S T U F X Y W}

toplevel $w -width 300 -height 150
#wm title . "Empty Hebrew"
wm title $w "Edit Hebrew/Greek"
#wm geometry . +50+50
wm geometry $w +100+100


canvas $c
frame $bh
frame $bg
frame $bb
text $wt -yscrollcommand "$ws set" -width 10 -height 8
scrollbar $ws -command "$wt yview"

pack $c -fill both -expand n
pack $bh -fill both -expand n
pack $bg -fill both -expand n
pack $bb -fill both -expand n
pack $wt -fill both -expand y -side left
pack $ws -side right -fill y
$c conf -height 30

button $bb.save -text "Save As" -command savefile
button $bb.tohebrew -text "Convert to Hebrew" \
       -command converthebrew
button $bb.togreek -text "Convert to Greek" \
       -command convertgreek
button $bb.html -text "Save As HTML" -command savehtml

pack $bb.save -expand n -fill none -side right
pack $bb.tohebrew -expand n -fill none -side right
pack $bb.togreek -expand n -fill none -side right
pack $bb.html -expand n -fill none -side right



set i 0
set ll 0

set imax [llength $hc]

image create photo Agr -file [file join Greekfont Agr.gif]
set imn [$c create image 200 20 -image Agr]
set tn  [$c create text  220 20 -text Agr -fill blue]

set ha(\$) Shin; set ha(\&) Shin; set ha(\ ) {\ };
set ga(J) Sgr; set ga(V) Ggr; set ga(\ ) {\ };
for {set i 0} {$i < $imax} {set i [expr $i + 1]} { 
   set n [lindex $hc $i]
   set ha([lindex $hcc $i]) $n
   image create photo $n \
         -file [file join Hebrewfont $n.gif]
   button $bh.b$n -image $n -command " \
      eval $c itemco $imn -image $n; \
      eval $c itemco $tn -text $n ;\
      eval global ll; eval set ll \[expr \$ll + 1\] ;\
      eval $wt image create insert -image $n -align top ;\
      eval $wt mark set insert insert-1c ;\
      eval $wt mark set current insert ;\
    " -borderwidth 1

   #puts $t
   pack $bh.b$n -expand y -fill both -side right
   if {[llength [split [lindex $hcc $i] {}]] == 1} {
      bind $wt <Alt-[lindex $hcc $i]> \
      [$bh.b$n cget -command]
   }
}
   button $bh.bSpace -text " " -command " \
      eval {$wt insert insert { }}  ; \
      eval $wt mark set insert insert-1c; \
      eval $wt mark set current insert; \
   " -borderwidth 1
   pack $bh.bSpace -expand y -fill both -side right

set imax [llength $gc]

for {set i 0} {$i < $imax} {set i [expr $i + 1]} { 
   set n [lindex $gc $i]
   set ga([lindex $gcc $i]) $n

   image create photo $n \
         -file [file join Greekfont $n.gif]
   button $bg.b$n -image $n -command " \
      eval $c itemco $imn -image $n; \
      eval $c itemco $tn -text $n ;\
      eval global ll; eval set ll \[expr \$ll + 1\] ;\
      eval $wt image create insert -image $n -align top ;\
    " -borderwidth 1

   #puts $t
   pack $bg.b$n -expand y -fill both -side right
   bind $wt <Shift-Control-[lindex $gcc $i]> \
      [$bg.b$n cget -command]
}

#button $b.$n -image $n {puts "$i $n"}
#pack $b.$n -side bottom

#bind .h <Key> {$b.b%Kgr invoke}

proc savefile {} {
   global wt
   set t [tk_getSaveFile]
   if {$t == {}} return
   set fd [open $t w]
   if {[file writable $t] == 0} return 
   puts $fd [$wt dump 0.0 end]
   close $fd
}

proc savehtml {} {
   global wt
   set t [tk_getSaveFile]
   if {$t == {}} return
   set fd [open $t w]
   if {[file writable $t] == 0} return 
   set f [open t2.html w];
   foreach {i j k} \
      [$wt dump -image -text 0.0 end] \
      {
        switch $i \
          {image} {\
           eval set j [lindex [split $j #] 0]; \
           if [string match *gr $j] \
             {set o "<IMG SRC=\"Greekfont/$j.gif\" ALIGN=TOP>"} \
             {set o "<IMG SRC=\"Hebrewfont/$j.gif\" ALIGN=TOP>"}; \
             puts -nonewline $fd $o \
          } \
          {text} \
             { puts $fd $j; \
               if {[string compare [string range $j end end] \n] == 0} \
                  {puts -nonewline $fd <BR>} \
             } \
      }
   close $fd   
}

#lrange [[lrange [$wt.l25 conf -image] end end] conf -file] end end
#foreach i [split $t {}] {if {$ha($i) != { }} {$bh.b$ha($i) invoke}}

proc converthebrew {} {
   global w wt ha bh
   set t [eval $wt get [$wt tag ranges sel]]
   eval $wt delete [$wt tag ranges sel]
   foreach i [split $t {}] { \
      if {[array get ha $i] != {}} { \
         if {$ha($i) != {\ }} { \
            $bh.b$ha($i) invoke \
         } { \
            $bh.bSpace invoke
         } \
      } \
   }
}
proc convertgreek {} {
   global w wt ga bg
   set t [eval $wt get [$wt tag ranges sel]]
   eval $wt delete [$wt tag ranges sel]
   foreach i [split $t {}] { \
      if {[array get ga $i] != {}} { \
         if {$ga($i) != {\ }} { \
            $bg.b$ga($i) invoke \
         } { \
            eval {$wt insert insert { }}
         } \
      } \
   }
}

proc readccat {} {
   foreach i  [split [lindex [split $w \t] 0] {}] { \
      set k [lindex [array get ha $i] 1]; \
      if {$k != {} } {if {$k == " "} \
         {$wt insert insert " "; $wt mark set insert insert-1c} \
         {eval $bh.b$ha($i) invoke}}
   }
}
